diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/mantissa.c olsrd-current/src/mantissa.c
--- olsrd-0.5.3/src/mantissa.c	2005-05-25 15:36:26.000000000 +0200
+++ olsrd-current/src/mantissa.c	2007-08-28 22:45:17.000000000 +0200
@@ -36,10 +36,9 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: mantissa.c,v 1.8 2005/05/25 13:36:26 kattemat Exp $
+ * $Id: mantissa.c,v 1.9 2007/08/28 20:45:17 bernd67 Exp $
  */
 
-
 #include "mantissa.h"
 
 /**
@@ -58,38 +57,77 @@
  */
 
 olsr_u8_t
-double_to_me(double interval)
+double_to_me(const double interval)
 {
-  olsr_u8_t a, b;
-
-  b = 0;
+    olsr_u8_t a, b;
 
-  while(interval / VTIME_SCALE_FACTOR >= (1<<b))
-    b++;
+    /* It is sufficent to compare the integer part since we test on >=.
+     * So we have now only a floating point division and the rest of the loop
+     * are only integer operations.
+     */
+    const unsigned int unscaled_interval = interval / VTIME_SCALE_FACTOR;
+    b = 0;
+    while (unscaled_interval >= (1U << b)) {
+        b++;
+    }
 
-  if(b == 0)
-    {
-      a = 1;
-      b = 0;
-    } 
-  else 
-    {
-      b--;
-      if (b > 15)
-	{
-	  a = 15;
-	  b = 15;
-	} 
-      else 
-	{ 
-	  a = (int)(16*((double)interval/(VTIME_SCALE_FACTOR*(double)(1<<b))-1));
-	  while(a >= 16)
-	    {
-	      a -= 16;
-	      b++;
-	    }
-	}
+    if(b == 0) {
+        a = 1;
+        b = 0;
+    } else {
+        b--;
+        if (b > 15) {
+            a = 15;
+            b = 15;
+        } else {
+            /* And again some maths simplification from the former version:
+             *    a = 16 * ((double)interval / (VTIME_SCALE_FACTOR * (double)(1 << b)) - 1)
+             * Since interval is already double:
+             *    a = 16 * (interval / (VTIME_SCALE_FACTOR * (double)(1 << b)) - 1)
+             * first, we can get rid of parentheses and change the * to a /
+             *    a = 16 * (interval / VTIME_SCALE_FACTOR / (double)(1 << b) - 1)
+             * then we make an integer addition from the floating point addition
+             *    a = (int)(16.0 * interval / VTIME_SCALE_FACTOR / (double)(1 << b)) - 16
+             * and we loose an unnecessary cast
+             *    a = (int)(16.0 * interval / VTIME_SCALE_FACTOR / (1 << b)) - 16
+             */
+            a = (int)(16.0 * interval / VTIME_SCALE_FACTOR / (1 << b)) - 16;
+            b += a >> 4;
+            a &= 0x0f;
+        }
     }
-  //printf("Generated mantissa/exponent(%d/%d): %d from %f\n", a, b, (olsr_u8_t) (a*16+b), interval);  //printf("Resolves back to: %f\n", ME_TO_DOUBLE(((a<<4)|(b&0x0F))));
-  return (olsr_u8_t) ((a<<4)|(b&0x0F));
+    //printf("Generated mantissa/exponent(%d/%d): %d from %f\n", a, b, (olsr_u8_t) (a*16+b), interval);  //printf("Resolves back to: %f\n", me_to_double(((a<<4)|(b&0x0F))));
+    return (a << 4) | (b & 0x0F);
+}
+
+/**
+ * Function for converting a mantissa/exponent 8bit value back
+ * to double as described in RFC3626:
+ *
+ * value = C*(1+a/16)*2^b [in seconds]
+ *
+ *  where a is the integer represented by the four highest bits of the
+ *  field and b the integer represented by the four lowest bits of the
+ *  field.
+ *
+ * me is the 8 bit mantissa/exponent value
+ *
+ * To avoid expensive floating maths, we transform the equation:
+ *     value = C * (1 + a / 16) * 2^b
+ * first, we make an int addition from the floating point addition:
+ *     value = C * ((16 + a) / 16) * 2^b
+ * then we get rid of a pair of parentheses
+ *     value = C * (16 + a) / 16 * 2^b
+ * and now we make an int multiplication from the floating point one
+ *     value = C * (16 + a) * 2^b / 16
+ * so that we can make a shift from the multiplication
+ *     value = C * ((16 + a) << b) / 16
+ * and sionce C and 16 are constants
+ *     value = ((16 + a) << b) * C / 16
+ */
+double me_to_double(const olsr_u8_t me)
+{
+    const olsr_u8_t a = me >> 4;
+    const olsr_u8_t b = me & 0x0F;
+    return ((16 + a) << b) * VTIME_SCALE_FACTOR / 16.0;
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/mantissa.h olsrd-current/src/mantissa.h
--- olsrd-0.5.3/src/mantissa.h	2005-05-29 14:47:45.000000000 +0200
+++ olsrd-current/src/mantissa.h	2007-08-28 22:45:17.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: mantissa.h,v 1.9 2005/05/29 12:47:45 br1 Exp $
+ * $Id: mantissa.h,v 1.10 2007/08/28 20:45:17 bernd67 Exp $
  */
 
 
@@ -60,10 +60,8 @@
  * me is the 8 bit mantissa/exponent value
  *
  */
-#define ME_TO_DOUBLE(me) \
-  (double)(VTIME_SCALE_FACTOR*(1+(double)(me>>4)/16)*(double)(1<<(me&0x0F)))
+double me_to_double(const olsr_u8_t);
 
-olsr_u8_t
-double_to_me(double);
+olsr_u8_t double_to_me(const double);
 
 #endif
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/mid_set.c olsrd-current/src/mid_set.c
--- olsrd-0.5.3/src/mid_set.c	2007-04-26 00:08:09.000000000 +0200
+++ olsrd-current/src/mid_set.c	2007-08-02 23:50:22.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: mid_set.c,v 1.20 2007/04/25 22:08:09 bernd67 Exp $
+ * $Id: mid_set.c,v 1.21 2007/08/02 21:50:22 bernd67 Exp $
  */
 
 #include "defs.h"
@@ -52,7 +52,7 @@
 struct mid_entry mid_set[HASHSIZE];
 struct mid_address reverse_mid_set[HASHSIZE];
 
-struct mid_entry *mid_lookup_entry_bymain(union olsr_ip_addr *adr);
+struct mid_entry *mid_lookup_entry_bymain(const union olsr_ip_addr *adr);
 
 /**
  * Initialize the MID set
@@ -62,7 +62,7 @@
 int
 olsr_init_mid_set(void)
 {
-  int index;
+  int idx;
 
   OLSR_PRINTF(5, "MID: init\n");
 
@@ -71,13 +71,13 @@
    */
   olsr_register_scheduler_event(&olsr_time_out_mid_set, NULL, 1, 0, NULL);
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
-      mid_set[index].next = &mid_set[index];
-      mid_set[index].prev = &mid_set[index];
+      mid_set[idx].next = &mid_set[idx];
+      mid_set[idx].prev = &mid_set[idx];
 
-      reverse_mid_set[index].next = &reverse_mid_set[index];
-      reverse_mid_set[index].prev = &reverse_mid_set[index];
+      reverse_mid_set[idx].next = &reverse_mid_set[idx];
+      reverse_mid_set[idx].prev = &reverse_mid_set[idx];
     }
 
   return 1;
@@ -96,7 +96,7 @@
  */
 
 void 
-insert_mid_tuple(union olsr_ip_addr *m_addr, struct mid_address *alias, float vtime)
+insert_mid_tuple(const union olsr_ip_addr *m_addr, struct mid_address *alias, float vtime)
 {
   struct mid_entry *tmp;
   struct mid_address *tmp_adr;
@@ -133,9 +133,9 @@
       alias->next_alias = tmp_adr;
       tmp->ass_timer = GET_TIMESTAMP(vtime*1000);
     }
-      /*Create new node*/
   else
     {
+      /*Create new node*/
       tmp = olsr_malloc(sizeof(struct mid_entry), "MID new alias");
 
       tmp->aliases = alias;
@@ -212,7 +212,7 @@
  *@return nada
  */
 void
-insert_mid_alias(union olsr_ip_addr *main_add, union olsr_ip_addr *alias, float vtime)
+insert_mid_alias(const union olsr_ip_addr *main_add, const union olsr_ip_addr *alias, float vtime)
 {
   struct mid_address *adr;
   struct neighbor_entry *ne_old, *ne_new;
@@ -260,9 +260,6 @@
   //print_mid_list();
 }
 
-
-
-
 /**
  *Lookup the main address for a alias address
  *
@@ -272,7 +269,7 @@
  *or NULL if not found
  */
 union olsr_ip_addr *
-mid_lookup_main_addr(union olsr_ip_addr *adr)
+mid_lookup_main_addr(const union olsr_ip_addr *adr)
 {
   olsr_u32_t hash;
   struct mid_address *tmp_list;
@@ -290,14 +287,13 @@
 
 }
 
-
 /* Find mid entry to an address.
  * @param adr the main address to search for
  *
  * @return a linked list of address structs
  */
 struct mid_entry *
-mid_lookup_entry_bymain(union olsr_ip_addr *adr)
+mid_lookup_entry_bymain(const union olsr_ip_addr *adr)
 {
   struct mid_entry *tmp_list;
   olsr_u32_t hash;
@@ -314,12 +310,9 @@
       if(COMP_IP(&tmp_list->main_addr, adr))
 	return tmp_list;
     }
-
-
   return NULL;
 }
 
-
 /*
  *Find all aliases for an address.
  *
@@ -328,7 +321,7 @@
  *@return a linked list of addresses structs
  */
 struct mid_address *
-mid_lookup_aliases(union olsr_ip_addr *adr)
+mid_lookup_aliases(const union olsr_ip_addr *adr)
 {
   struct mid_entry *tmp = mid_lookup_entry_bymain(adr);
   return tmp ? tmp->aliases : NULL;
@@ -343,7 +336,7 @@
  *@return 1 if the node was updated, 0 if not
  */
 int
-olsr_update_mid_table(union olsr_ip_addr *adr, float vtime)
+olsr_update_mid_table(const union olsr_ip_addr *adr, float vtime)
 {
   struct mid_entry *tmp_list = mid_set;
   olsr_u32_t hash;
@@ -378,7 +371,7 @@
  *@return nada
  */
 void
-olsr_prune_aliases(union olsr_ip_addr *m_addr, struct mid_alias *declared_aliases)
+olsr_prune_aliases(const union olsr_ip_addr *m_addr, struct mid_alias *declared_aliases)
 {
   struct mid_entry *entry;
   olsr_u32_t hash;
@@ -405,7 +398,7 @@
   registered_aliases = entry->aliases;
   previous_alias = NULL;
 
-  while(registered_aliases != 0)
+  while(registered_aliases != NULL)
     {
       struct mid_address *current_alias = registered_aliases;
       registered_aliases = registered_aliases->next_alias;
@@ -419,7 +412,7 @@
           declared_aliases = declared_aliases->next;
         }
 
-      if (declared_aliases == 0)
+      if (declared_aliases == NULL)
         {
           /* Current alias not found in list of declared aliases: free current alias */
           OLSR_PRINTF(1, "MID remove: (%s, ", olsr_ip_to_string(&entry->main_addr));
@@ -463,14 +456,13 @@
 void
 olsr_time_out_mid_set(void *foo __attribute__((unused)))
 {
-  int index;
-
+  int idx;
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
-      struct mid_entry *tmp_list = mid_set[index].next;
+      struct mid_entry *tmp_list = mid_set[idx].next;
       /*Traverse MID list*/
-      while(tmp_list != &mid_set[index])
+      while(tmp_list != &mid_set[idx])
 	{
 	  /*Check if the entry is timed out*/
 	  if(TIMED_OUT(tmp_list->ass_timer))
@@ -529,15 +521,15 @@
 void
 olsr_print_mid_set(void)
 {
-  int index;
+  int idx;
 
   OLSR_PRINTF(1, "mid set: %02d:%02d:%02d.%06lu\n",nowtm->tm_hour, nowtm->tm_min, nowtm->tm_sec, now.tv_usec);
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
-      struct mid_entry *tmp_list = mid_set[index].next;
+      struct mid_entry *tmp_list = mid_set[idx].next;
       /*Traverse MID list*/
-      for(tmp_list = mid_set[index].next; tmp_list != &mid_set[index]; tmp_list = tmp_list->next)
+      for(tmp_list = mid_set[idx].next; tmp_list != &mid_set[idx]; tmp_list = tmp_list->next)
 	{
 	  struct mid_address *tmp_addr;
           
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/mid_set.h olsrd-current/src/mid_set.h
--- olsrd-0.5.3/src/mid_set.h	2007-02-10 20:27:32.000000000 +0100
+++ olsrd-current/src/mid_set.h	2007-08-02 23:50:22.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: mid_set.h,v 1.14 2007/02/10 19:27:32 bernd67 Exp $
+ * $Id: mid_set.h,v 1.15 2007/08/02 21:50:22 bernd67 Exp $
  */
 
 
@@ -45,6 +45,7 @@
 
 #include "olsr_types.h"
 
+
 struct mid_address
 {
   union olsr_ip_addr  alias;
@@ -79,16 +80,16 @@
 olsr_init_mid_set(void);
 
 void 
-insert_mid_tuple(union olsr_ip_addr *, struct mid_address *, float);
+insert_mid_tuple(const union olsr_ip_addr *, struct mid_address *, float);
 
 void
-insert_mid_alias(union olsr_ip_addr *, union olsr_ip_addr *, float);
+insert_mid_alias(const union olsr_ip_addr *, const union olsr_ip_addr *, float);
 
 union olsr_ip_addr *
-mid_lookup_main_addr(union olsr_ip_addr *);
+mid_lookup_main_addr(const union olsr_ip_addr *);
 
 struct mid_address *
-mid_lookup_aliases(union olsr_ip_addr *);
+mid_lookup_aliases(const union olsr_ip_addr *);
 
 void
 olsr_print_mid_set(void);
@@ -97,10 +98,10 @@
 olsr_time_out_mid_set(void *);
 
 void
-olsr_prune_aliases(union olsr_ip_addr *m_addr, struct mid_alias *declared_aliases);
+olsr_prune_aliases(const union olsr_ip_addr *m_addr, struct mid_alias *declared_aliases);
 
 int
-olsr_update_mid_table(union olsr_ip_addr *, float);
+olsr_update_mid_table(const union olsr_ip_addr *, float);
 
 int
 mid_delete_node(struct mid_entry *);
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/neighbor_table.c olsrd-current/src/neighbor_table.c
--- olsrd-0.5.3/src/neighbor_table.c	2007-04-26 00:08:09.000000000 +0200
+++ olsrd-current/src/neighbor_table.c	2007-08-02 23:57:06.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: neighbor_table.c,v 1.32 2007/04/25 22:08:09 bernd67 Exp $
+ * $Id: neighbor_table.c,v 1.33 2007/08/02 21:57:06 bernd67 Exp $
  */
 
 
@@ -89,8 +89,7 @@
   entry = neighbor->neighbor_2_list.next;
 
   while(entry != &neighbor->neighbor_2_list)
-    {
-      
+    {      
       if(COMP_IP(&entry->neighbor_2->neighbor_2_addr, address))
 	{
 	  /* Dequeue */
@@ -117,9 +116,8 @@
  *representing the two hop neighbor if found. NULL if not found.
  */
 struct neighbor_2_list_entry *
-olsr_lookup_my_neighbors(struct neighbor_entry *neighbor, union olsr_ip_addr *neighbor_main_address)
+olsr_lookup_my_neighbors(const struct neighbor_entry *neighbor, const union olsr_ip_addr *neighbor_main_address)
 {
-  
   struct neighbor_2_list_entry *entry;
   
   for(entry = neighbor->neighbor_2_list.next;
@@ -147,7 +145,7 @@
  */
 
 int
-olsr_delete_neighbor_table(union olsr_ip_addr *neighbor_addr)
+olsr_delete_neighbor_table(const union olsr_ip_addr *neighbor_addr)
 {  
   struct  neighbor_2_list_entry *two_hop_list, *two_hop_to_delete;
   olsr_u32_t                    hash;
@@ -178,9 +176,7 @@
 
   while(two_hop_list != &entry->neighbor_2_list)
     {
-      struct  neighbor_2_entry *two_hop_entry;
-
-      two_hop_entry = two_hop_list->neighbor_2;
+      struct neighbor_2_entry *two_hop_entry = two_hop_list->neighbor_2;
       
       two_hop_entry->neighbor_2_pointer--;
 
@@ -223,7 +219,7 @@
  *@return 0 if neighbor already exists 1 if inserted
  */
 struct neighbor_entry *
-olsr_insert_neighbor_table(union olsr_ip_addr *main_addr)
+olsr_insert_neighbor_table(const union olsr_ip_addr *main_addr)
 {
   olsr_u32_t             hash;
   struct neighbor_entry  *new_neigh;
@@ -273,35 +269,15 @@
  *address. NULL if not found.
  */
 struct neighbor_entry *
-olsr_lookup_neighbor_table(union olsr_ip_addr *dst)
+olsr_lookup_neighbor_table(const union olsr_ip_addr *dst)
 {
-  struct neighbor_entry  *entry;
-  olsr_u32_t             hash;
-  union olsr_ip_addr     *tmp_ip;
-
   /*
    *Find main address of node
    */
-  if((tmp_ip = mid_lookup_main_addr(dst)) != NULL)
+  union olsr_ip_addr *tmp_ip = mid_lookup_main_addr(dst);
+  if(tmp_ip != NULL)
     dst = tmp_ip;
-  
-  hash = olsr_hashing(dst);
-
-  
-  //printf("\nLookup %s\n", olsr_ip_to_string(dst));
-  for(entry = neighbortable[hash].next;
-      entry != &neighbortable[hash];
-      entry = entry->next)
-    {
-      //printf("Checking %s\n", olsr_ip_to_string(&neighbor_table_tmp->neighbor_main_addr));
-      if(COMP_IP(&entry->neighbor_main_addr, dst))
-	return entry;
-      
-    }
-  //printf("NOPE\n\n");
-
-  return NULL;
-
+  return olsr_lookup_neighbor_table_alias(dst);
 }
 
 
@@ -314,13 +290,10 @@
  *address. NULL if not found.
  */
 struct neighbor_entry *
-olsr_lookup_neighbor_table_alias(union olsr_ip_addr *dst)
+olsr_lookup_neighbor_table_alias(const union olsr_ip_addr *dst)
 {
   struct neighbor_entry  *entry;
-  olsr_u32_t             hash;
-  
-  hash = olsr_hashing(dst);
-
+  olsr_u32_t             hash = olsr_hashing(dst);
   
   //printf("\nLookup %s\n", olsr_ip_to_string(dst));
   for(entry = neighbortable[hash].next;
@@ -341,13 +314,13 @@
 
 
 int
-update_neighbor_status(struct neighbor_entry *entry, int link)
+update_neighbor_status(struct neighbor_entry *entry, int lnk)
 {
   /*
    * Update neighbor entry
    */
  
-  if(link == SYM_LINK)
+  if(lnk == SYM_LINK)
     {
       /* N_status is set to SYM */
       if(entry->status == NOT_SYM)
@@ -397,9 +370,7 @@
 void
 olsr_time_out_two_hop_neighbors(struct neighbor_entry  *neighbor)
 {
-  struct neighbor_2_list_entry *two_hop_list;
-
-  two_hop_list = neighbor->neighbor_2_list.next;
+  struct neighbor_2_list_entry *two_hop_list = neighbor->neighbor_2_list.next;
 
   while(two_hop_list != &neighbor->neighbor_2_list)
     {
@@ -414,7 +385,7 @@
 	  if(two_hop_entry->neighbor_2_pointer < 1)
 	    {
 	      DEQUEUE_ELEM(two_hop_entry);
-	      free((void *)two_hop_entry);
+	      free(two_hop_entry);
 	    }
 	  
 	  two_hop_to_delete = two_hop_list;
@@ -439,12 +410,12 @@
 void
 olsr_time_out_neighborhood_tables(void)
 {
-  olsr_u8_t index;
+  int idx;
   
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
       struct neighbor_entry *entry;
-      for(entry = neighbortable[index].next; entry != &neighbortable[index]; entry = entry->next)
+      for(entry = neighbortable[idx].next; entry != &neighbortable[idx]; entry = entry->next)
 	{	  
 	  olsr_time_out_two_hop_neighbors(entry);
 	}
@@ -485,11 +456,11 @@
       struct neighbor_entry *neigh;
       for(neigh = neighbortable[i].next; neigh != &neighbortable[i]; neigh = neigh->next)
 	{
-	  struct link_entry *link = get_best_link_to_neighbor(&neigh->neighbor_main_addr);
-	  if(link)
+	  struct link_entry *lnk = get_best_link_to_neighbor(&neigh->neighbor_main_addr);
+	  if(lnk)
             {
-              double best_lq = link->neigh_link_quality;
-              double inv_best_lq = link->loss_link_quality;
+              const double best_lq = lnk->neigh_link_quality;
+              const double inv_best_lq = lnk->loss_link_quality;
 
               OLSR_PRINTF(1, fstr, olsr_ip_to_string(&neigh->neighbor_main_addr),
                           inv_best_lq, best_lq,
@@ -501,13 +472,3 @@
         }
     }
 }
-
-
-
-
-
-
-
-
-
-
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/neighbor_table.h olsrd-current/src/neighbor_table.h
--- olsrd-0.5.3/src/neighbor_table.h	2005-05-29 14:47:45.000000000 +0200
+++ olsrd-current/src/neighbor_table.h	2007-08-02 23:57:06.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: neighbor_table.h,v 1.14 2005/05/29 12:47:45 br1 Exp $
+ * $Id: neighbor_table.h,v 1.15 2007/08/02 21:57:06 bernd67 Exp $
  */
 
 
@@ -86,19 +86,19 @@
 olsr_delete_neighbor_2_pointer(struct neighbor_entry *, union olsr_ip_addr *);
 
 struct neighbor_2_list_entry *
-olsr_lookup_my_neighbors(struct neighbor_entry *, union olsr_ip_addr *);
+olsr_lookup_my_neighbors(const struct neighbor_entry *, const union olsr_ip_addr *);
 
 int
-olsr_delete_neighbor_table(union olsr_ip_addr *);
+olsr_delete_neighbor_table(const union olsr_ip_addr *);
 
 struct neighbor_entry *
-olsr_insert_neighbor_table(union olsr_ip_addr *);
+olsr_insert_neighbor_table(const union olsr_ip_addr *);
 
 struct neighbor_entry *
-olsr_lookup_neighbor_table(union olsr_ip_addr *);
+olsr_lookup_neighbor_table(const union olsr_ip_addr *);
 
 struct neighbor_entry *
-olsr_lookup_neighbor_table_alias(union olsr_ip_addr *);
+olsr_lookup_neighbor_table_alias(const union olsr_ip_addr *);
 
 void
 olsr_time_out_two_hop_neighbors(struct neighbor_entry  *);
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/net_olsr.c olsrd-current/src/net_olsr.c
--- olsrd-0.5.3/src/net_olsr.c	2007-07-06 00:43:47.000000000 +0200
+++ olsrd-current/src/net_olsr.c	2007-08-28 22:10:16.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: net_olsr.c,v 1.24 2007/07/05 22:43:47 bernd67 Exp $
+ * $Id: net_olsr.c,v 1.28 2007/08/28 20:10:16 bernd67 Exp $
  */
 
 #include "net_olsr.h"
@@ -45,11 +45,11 @@
 #include "net_os.h"
 #include "print_packet.h"
 #include "link_set.h"
+#include "lq_packet.h"
+
 #include <stdlib.h>
 #include <assert.h>
 
-extern olsr_bool lq_tc_pending;
-
 static olsr_bool disp_pack_out = OLSR_FALSE;
 
 
@@ -102,40 +102,16 @@
 void
 init_net(void)
 {
-  /* Block invalid addresses */
-  if(olsr_cnf->ip_version == AF_INET)
-    {
-      union olsr_ip_addr addr;
-      int i;
-      /* IPv4 */
-      for(i = 0; deny_ipv4_defaults[i] != NULL; i++)
-	{
-	  if(inet_pton(olsr_cnf->ip_version, deny_ipv4_defaults[i], &addr) <= 0)
-	    {
-	      fprintf(stderr, "Error converting fixed IP %s for deny rule!!\n",
-		      deny_ipv4_defaults[i]);
-	      continue;
-	    }
-	  olsr_add_invalid_address(&addr);
-	}
-    }
-  else 
-    {
-      union olsr_ip_addr addr;
-      int i;
-      /* IPv6 */
-      for(i = 0; deny_ipv6_defaults[i] != NULL; i++)
-	{
-	  if(inet_pton(olsr_cnf->ip_version, deny_ipv6_defaults[i], &addr) <= 0)
-	    {
-	      fprintf(stderr, "Error converting fixed IP %s for deny rule!!\n",
-		      deny_ipv6_defaults[i]);
-	      continue;
-	    }
-	  olsr_add_invalid_address(&addr);
-	}
-
+  const char * const *defaults = olsr_cnf->ip_version == AF_INET ? deny_ipv4_defaults : deny_ipv6_defaults;
+  
+  for (; *defaults != NULL; defaults++) {
+    union olsr_ip_addr addr;
+    if(inet_pton(olsr_cnf->ip_version, *defaults, &addr) <= 0){
+      fprintf(stderr, "Error converting fixed IP %s for deny rule!!\n", *defaults);
+      continue;
     }
+    olsr_add_invalid_address(&addr);
+  }
 }
 
 /**
@@ -521,14 +497,12 @@
  * @return the prefix length
  */
 olsr_u16_t
-olsr_netmask_to_prefix(union olsr_ip_addr *adr)
+olsr_netmask_to_prefix(const union olsr_ip_addr *adr)
 {
-  olsr_u16_t prefix;
-  int i, tmp;
+  int i;
+  olsr_u16_t prefix = 0;
 
-  prefix = 0;
-
-  for(i = 0; i < 16; i++)
+  for (i = 0; i < 16; i++)
     {
       if(adr->v6.s6_addr[i] == 0xff)
 	{
@@ -536,6 +510,7 @@
 	}
       else
 	{
+          int tmp;
 	  for(tmp = adr->v6.s6_addr[i];
 	      tmp > 0;
 	      tmp = (tmp << 1) & 0xff)
@@ -562,12 +537,10 @@
  *@return a char pointer to the string containing the IP
  */
 char *
-sockaddr_to_string(struct sockaddr *address_to_convert)
+sockaddr_to_string(const struct sockaddr *address_to_convert)
 {
-  struct sockaddr_in           *address;
-  
-  address=(struct sockaddr_in *)address_to_convert; 
-  return(inet_ntoa(address->sin_addr));
+  const struct sockaddr_in *address = (const struct sockaddr_in *)address_to_convert; 
+  return inet_ntoa(address->sin_addr);
   
 }
 
@@ -612,7 +585,7 @@
 const char *
 olsr_ip_to_string(const union olsr_ip_addr *addr)
 {
-  static int index = 0;
+  static int idx = 0;
   static char buff[4][INET6_ADDRSTRLEN > INET_ADDRSTRLEN ? INET6_ADDRSTRLEN : INET_ADDRSTRLEN];
   const char *ret;
 
@@ -625,24 +598,24 @@
 #if 0
       struct in_addr in;
       in.s_addr = addr->v4;
-      ret = inet_ntop(AF_INET, &in, buff[index], sizeof(buff[index]));
+      ret = inet_ntop(AF_INET, &in, buff[idx], sizeof(buff[idx]));
 #else
-      ret = inet_ntop(AF_INET, &addr->v6, buff[index], sizeof(buff[index]));
+      ret = inet_ntop(AF_INET, &addr->v4, buff[idx], sizeof(buff[idx]));
 #endif
     }
   else
     {
       /* IPv6 */
-      ret = inet_ntop(AF_INET6, &addr->v6, buff[index], sizeof(buff[index]));
+      ret = inet_ntop(AF_INET6, &addr->v6, buff[idx], sizeof(buff[idx]));
     }
-  index = (index + 1) & 3;
+  idx = (idx + 1) & 3;
 
   return ret;
 }
 
 
 void
-olsr_add_invalid_address(union olsr_ip_addr *adr)
+olsr_add_invalid_address(const union olsr_ip_addr *adr)
 {
   struct deny_address_entry *new_entry;
 
@@ -667,9 +640,9 @@
  *@return a char pointer to the string containing the IP
  */
 olsr_bool
-olsr_validate_address(union olsr_ip_addr *adr)
+olsr_validate_address(const union olsr_ip_addr *adr)
 {
-  struct deny_address_entry *deny_entry = deny_entries;
+  const struct deny_address_entry *deny_entry = deny_entries;
 
   while(deny_entry)
     {
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/net_olsr.h olsrd-current/src/net_olsr.h
--- olsrd-0.5.3/src/net_olsr.h	2007-04-26 00:08:09.000000000 +0200
+++ olsrd-current/src/net_olsr.h	2007-08-20 20:46:03.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: net_olsr.h,v 1.9 2007/04/25 22:08:09 bernd67 Exp $
+ * $Id: net_olsr.h,v 1.10 2007/08/20 18:46:03 bernd67 Exp $
  */
 
 
@@ -88,10 +88,10 @@
 olsr_prefix_to_netmask(union olsr_ip_addr *, olsr_u16_t);
 
 olsr_u16_t
-olsr_netmask_to_prefix(union olsr_ip_addr *);
+olsr_netmask_to_prefix(const union olsr_ip_addr *);
 
 char *
-sockaddr_to_string(struct sockaddr *);
+sockaddr_to_string(const struct sockaddr *);
 
 const char *
 ip_to_string(const olsr_u32_t *);
@@ -109,9 +109,9 @@
 del_ptf(packet_transform_function);
 
 olsr_bool
-olsr_validate_address(union olsr_ip_addr *);
+olsr_validate_address(const union olsr_ip_addr *);
 
 void
-olsr_add_invalid_address(union olsr_ip_addr *);
+olsr_add_invalid_address(const union olsr_ip_addr *);
 
 #endif
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/olsrd_plugin.h olsrd-current/src/olsrd_plugin.h
--- olsrd-0.5.3/src/olsrd_plugin.h	2007-07-15 21:29:37.000000000 +0200
+++ olsrd-current/src/olsrd_plugin.h	2007-08-25 21:48:42.000000000 +0200
@@ -29,7 +29,7 @@
  *
  */
 
-/* $Id: olsrd_plugin.h,v 1.3 2007/07/15 19:29:37 bernd67 Exp $ */
+/* $Id: olsrd_plugin.h,v 1.4 2007/08/25 19:48:42 bernd67 Exp $ */
 
 /*
  * Example plugin for olsrd.org OLSR daemon
@@ -78,12 +78,13 @@
 
 /* Interface version 5 */
 
-typedef int (*set_plugin_parameter)(const char *value, void *data);
+typedef int (*set_plugin_parameter)(const char *value, void *data, unsigned int addon);
 
 struct olsrd_plugin_parameters {
     const char *name;
     set_plugin_parameter set_plugin_parameter;
     void *data;
+    unsigned int addon;
 };
 
 /**
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/packet.c olsrd-current/src/packet.c
--- olsrd-0.5.3/src/packet.c	2007-04-26 00:08:09.000000000 +0200
+++ olsrd-current/src/packet.c	2007-08-03 00:07:19.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: packet.c,v 1.22 2007/04/25 22:08:09 bernd67 Exp $
+ * $Id: packet.c,v 1.23 2007/08/02 22:07:19 bernd67 Exp $
  */
 
 
@@ -90,8 +90,7 @@
   struct hello_neighbor   *message_neighbor, *tmp_neigh;
   struct link_entry       *links;
   struct neighbor_entry   *neighbor;
-  olsr_u16_t              index;
-  int                     link;
+  int                     idx;
 
 #ifdef DEBUG
   OLSR_PRINTF(3, "\tBuilding HELLO on interface %d\n", outif->if_nr);
@@ -123,8 +122,7 @@
 
   while(links != NULL)
     {      
-      
-      link = lookup_link_status(links);
+      int lnk = lookup_link_status(links);
       /* Update the status */
       
       /* Check if this link tuple is registered on the outgoing interface */
@@ -138,7 +136,7 @@
       
 
       /* Find the link status */
-      message_neighbor->link = link;
+      message_neighbor->link = lnk;
 
       /*
        * Calculate neighbor status
@@ -213,10 +211,10 @@
   /* Add the rest of the neighbors if running on multiple interfaces */
   
   if(ifnet != NULL && ifnet->int_next != NULL)
-    for(index=0;index<HASHSIZE;index++)
+    for(idx=0;idx<HASHSIZE;idx++)
       {       
-	for(neighbor = neighbortable[index].next;
-	    neighbor != &neighbortable[index];
+	for(neighbor = neighbortable[idx].next;
+	    neighbor != &neighbortable[idx];
 	    neighbor=neighbor->next)
 	  {
 	    /* Check that the neighbor is not added yet */
@@ -339,12 +337,11 @@
 int
 olsr_build_tc_packet(struct tc_message *message)
 {
-  struct tc_mpr_addr        *message_mpr;
+  struct tc_mpr_addr     *message_mpr;
   //struct mpr_selector       *mprs;
-  olsr_u8_t              index;
+  int                     idx;
   struct neighbor_entry  *entry;
   //struct mpr_selector_hash  *mprs_hash;
-  //olsr_u16_t          index;
   olsr_bool entry_added = OLSR_FALSE;
 
   message->multipoint_relay_selector_address=NULL;
@@ -359,10 +356,10 @@
   
 
   /* Loop trough all neighbors */  
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
-      for(entry = neighbortable[index].next;
-	  entry != &neighbortable[index];
+      for(entry = neighbortable[idx].next;
+	  entry != &neighbortable[idx];
 	  entry = entry->next)
 	{
 	  if(entry->status != SYM)
@@ -417,7 +414,7 @@
 	  
 	    } /* Switch */
 	} /* For */
-    } /* For index */
+    } /* For idx */
 
   if(entry_added)
     {
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/plugin_loader.c olsrd-current/src/plugin_loader.c
--- olsrd-0.5.3/src/plugin_loader.c	2007-08-01 18:16:05.000000000 +0200
+++ olsrd-current/src/plugin_loader.c	2007-08-31 00:25:13.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: plugin_loader.c,v 1.29 2007/08/01 16:16:05 bernd67 Exp $
+ * $Id: plugin_loader.c,v 1.31 2007/08/30 22:25:13 bernd67 Exp $
  */
 
 #include "plugin_loader.h"
@@ -211,7 +211,8 @@
 
         plugin->register_param = dlsym(plugin->dlhandle, "olsrd_plugin_register_param");
         if(plugin->register_param == NULL) {
-            OLSR_PRINTF(1, "FAILED: \"%s\"\n", dlerror());
+            OLSR_PRINTF(0, "FAILED: \"%s\"\n", dlerror());
+            return -1;
         } else {
             OLSR_PRINTF(1, "OK\n");
         }
@@ -248,9 +249,12 @@
             unsigned int i;
             int rc = 0;
             for (i = 0; i < entry->plugin_parameters_size; i++) {
-                if (strcasecmp(entry->plugin_parameters[i].name, params->key) == 0) {
+                if (0 == entry->plugin_parameters[i].name[0] ||
+                    0 == strcasecmp(entry->plugin_parameters[i].name, params->key))
+                {
                     /* we have found it! */
-                    rc = entry->plugin_parameters[i].set_plugin_parameter(params->value, entry->plugin_parameters[i].data);
+                    rc = entry->plugin_parameters[i].set_plugin_parameter(params->value, entry->plugin_parameters[i].data,
+                        0 == entry->plugin_parameters[i].name[0] ? (unsigned int)params->key : entry->plugin_parameters[i].addon);
                     if (rc != 0) {
                         fprintf(stderr, "\nFatal error in plugin parameter \"%s\"/\"%s\"\n", params->key, params->value);
                         rv = -1;
